# Guide to contributing

Please read this if you intend to contribute to the project.

## First things

* Get a github account if you don't have one already
* Submit a github issue if there isn't one already.
  * Clearly describe the bug or feature
  * Provide exact reproducable steps to reproduce the issue if its a bug
  * Include the versions of all components
* Fork the repository on github

## Making your changes

* Create a new branch for your changes
* Make your changes
* Make sure you include tests
* Make sure the test suite passes after your changes
* Commit your changes into that branch
* Use descriptive and meaningful commit messages
* If you have a lot of commits squash them into a single commit
* Push your changes to your branch in your forked repository

## Submitting the changes

Before submitting your pull request you must sign the [Eclipse Foundation Contributor License Agreement](http://www.eclipse.org/legal/CLA.php).

We will NOT ACCEPT any contributions without this first being signed.

To sign the Eclipse CLA you need to:

* Obtain an Eclipse Foundation userid. Anyone who currently uses Eclipse Bugzilla or Gerrit systems already has one of those.
If you don’t, you need to [register](https://dev.eclipse.org/site_login/createaccount.php).

* Login into the [projects portal](https://projects.eclipse.org/), select “My Account”, and then the “Contributor License Agreement” tab.
 
## After submitting

* Once you have signed the Eclipse CLA, make a note on the github issue that you have signed the CLA, and then you can submit a pull request via github.
* Do not use your branch for any other development, otherwise further changes that you make will be visible in the PR.



